import parser._
import fun._
val pref = ProgFun.parse(
  """
    let r = ref 0 in
      r := !r + 1;
      r := !r + 1;
      !r
    end
  """)
eval(pref)

val pref2 = ProgFun.parse(
"""
  let r = ref 0 in
    (r := !r + 1; !r) + (r := !r + 1; !r)
  end
""")
eval(pref2)

val preffun = ProgFun.parse(
"""
fun f(a, b, c)
  a - b - c
end

let r = ref 0 in
  f((r := !r + 1; !r),
    (r := !r + 1; throw "erro aqui"; !r),
    (r := !r + 1; !r))
end
""")
eval(preffun) // avalia args da direita pra esquerda
evals(preffun)
val prefref = ProgFun.parse(
"""
  let c = ref 0 in
    (c := !c + 1; c) := !c + 1
  end
""".stripMargin
)
eval(prefref)
val pderef = ProgFun.parse(
"""
  let c = ref 0 in
    !(c := 1; c)
  end
""".stripMargin
)
eval(pderef)
val pthrow = ProgFun.parse(
  """
fun f(a, b, c)
  a - b - c
end
try
  let r = ref 0 in
    try
      f((r := !r + 1; !r),
        (r := !r + 1; throw "erro aqui"; !r),
        (r := !r + 1; !r))
    finally
      r := 0
    end
  end
catch
  let r = ref 1 in
    throw "erro aqui de novo"
  end
finally
  throw "erro no finally"
end
  """)
eval(pthrow) // avalia args da direita pra esquerda
evals(pthrow) // avalia args da direita pra esquerda
